POJ 3126 Prime Path(BFS)

Prime Path
Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 12616   Accepted: 7145

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

題目大意:

這道題目是說,給你一個l和r,並且l和r都是素數,問你如何通過最小的步數使得l變成r,並且每次變化只能變一個位置的數字,且每次變化完後都是素數

解題思路:

直接bfs就好,每次將個位,十位,百位,千位的變化後的數字壓入隊列,然後判斷是不是使我們所要求的那個數字,然後記錄步數就好了。


代碼:

# include<cstdio>
# include<iostream>
# include<cstring>
# include<queue>

using namespace std;

# define MAX 10000

int prime[MAX];
int book[MAX];
int path[MAX];
int l,r;

void init()
{
    for ( int i = 2;i < 10000;i++ )
    {
        prime[i] = 1;
    }
    for ( int i = 2;i < 100;i++ )
    {
        if ( prime[i] )
        {
            for ( int j = 1;i*j < 10000;j++ )
            {
                prime[i*j] = 0;
            }
        }
    }
}

void bfs()
{
        queue<int>q;
        q.push(l);
        book[l] = 1;
        while ( !q.empty() )
        {
            int temp = q.front();
            q.pop();
            if ( temp == r )
                break;

            for ( int t = 1;t <= 1000;t*=10 )
            {
                int d = temp;
                d/=t;
                d%=10;
                int rec = temp-d*t;
                for ( int j = 0;j <= 9;j++ )
                {
                    if ( t == 1000&&j==0 )
                    {
                        continue;
                    }
                    if ( j!=d )
                    {
                        int cur = j*t+rec;

                        if ( prime[cur]==1&&book[cur]==0 )
                        {
                            q.push(cur);
                            path[cur] = path[temp]+1;
                            book[cur] = 1;
                        }

                    }
                }

            }

        }
}


int main(void)
{
    int t;cin>>t;
    while ( t-- )
    {
        memset(book,0,sizeof(book));
        memset(path,0,sizeof(path));
        cin>>l>>r;
        init();
        bfs();
        cout<<path[r]<<endl;

    }


    return 0;
}


發表評論
所有評論
還沒有人評論,想成為第一個評論的人麼? 請在上方評論欄輸入並且點擊發布.
相關文章